"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk = require("chalk");
function middleware(req, res, next) {
    let time = `[${chalk.blue(getDateTime())}]`;
    let method = `[${chalk.green('HTTP')}] [${chalk.green('<-')}] ` +
        `${chalk.yellow(res.statusCode.toString())} ${req.method}`;
    let url = `${req.originalUrl}`;
    let name = res.locals.remote_user && res.locals.remote_user.name || 'anonymous';
    let ip = req.headers['x-forwarded-for'] || req.connection.remoteAddress;
    let userInfo = `${name}${chalk.yellow('@')}${ip}`;
    console.log(`${time} ${method} ${url} - ${userInfo}`);
    next();
}
exports.middleware = middleware;
function httpIn(url, method, res) {
    let statusCode = res && res.statusCode ? res.statusCode.toString() : '200';
    let time = `[${chalk.blue(getDateTime())}]`;
    let httpMethod = `[${chalk.cyan('HTTP')}] [${chalk.cyan('<-')}] ` +
        `${chalk.yellow(statusCode)} ${method}`;
    console.log(`${time} ${httpMethod} ${url}`);
}
exports.httpIn = httpIn;
function httpOut(url, method, statusCode) {
    let time = `[${chalk.blue(getDateTime())}]`;
    let httpMethod = `[${chalk.green('HTTP')}] [${chalk.green('->')}] ` +
        `${chalk.yellow(statusCode)} ${method}`;
    console.log(`${time} ${httpMethod} ${url}`);
}
exports.httpOut = httpOut;
function info(msg) {
    let time = `[${chalk.blue(getDateTime())}]`;
    let method = `[${chalk.yellow('INFO')}] [${chalk.yellow('--')}]`;
    console.log(`${time} ${method} ${msg}`);
}
exports.info = info;
function getDateTime() {
    return new Date().toISOString().replace(/T/, ' ').replace(/\..+/, '');
}
