"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
const logger = require("./logger");
function fetchUpstreamData(upstreamUrl, pkgName, baseUrl) {
    let fetchUrl = upstreamUrl + '/' + pkgName;
    return getResponse(fetchUrl).then(body => {
        return body;
    });
}
exports.fetchUpstreamData = fetchUpstreamData;
function changeUpstreamDistUrls(upstreamUrl, baseUrl, body) {
    let versions = Object.keys(body.versions).reduce((acc, curr) => {
        acc[curr] = body.versions[curr];
        acc[curr].dist.tarball = acc[curr].dist.tarball.replace(upstreamUrl, baseUrl);
        delete acc[curr]._npmOperationalInternal;
        return acc;
    }, {});
    body.versions = versions;
    return body;
}
exports.changeUpstreamDistUrls = changeUpstreamDistUrls;
function getResponse(url) {
    return new Promise((resolve, reject) => {
        request(url, { method: 'GET' }, (err, resp, body) => {
            if (err) {
                logger.httpOut(url, 'GET', '500');
                reject(err);
            }
            logger.httpOut(url, 'GET', '200');
            resolve(JSON.parse(body));
        });
    });
}
