"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("./package");
const fs_1 = require("./fs");
const utils_1 = require("./utils");
const logger_1 = require("./logger");
exports.storage = [];
function initializeStorage() {
    let rootDir = utils_1.getFilePath('packages');
    let startTime = new Date().getTime();
    return fs_1.globSearch(`${rootDir}/**/package.json`)
        .then(packages => {
        return Promise.all(packages.map(jsonPath => {
            return fs_1.readJsonFile(jsonPath).then((pkgJsonData) => {
                exports.storage.push(pkgJsonData);
            });
        })).then(() => {
            let time = new Date().getTime() - startTime;
            logger_1.info(`storage initialized in ${time}ms`);
        });
    })
        .catch(err => console.error(err));
}
exports.initializeStorage = initializeStorage;
function updatePkgStorage(pkgName) {
    let pkg = new package_1.Package(null, name);
    return pkg.initDataFromPkgJson();
}
exports.updatePkgStorage = updatePkgStorage;
function findPackage(pkgName) {
    let index = exports.storage.findIndex(pkg => pkg.name === pkgName);
    return exports.storage[index] || null;
}
exports.findPackage = findPackage;
